/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20200430 (64-bit version)
 * Copyright (c) 2000 - 2020 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT9.aml, Fri May 22 18:22:26 2020
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00001EB7 (7863)
 *     Revision         0x01
 *     Checksum         0x4D
 *     OEM ID           "HP"
 *     OEM Table ID     "DETACHPC"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20121018 (538054680)
 */
DefinitionBlock ("", "SSDT", 1, "HP", "DETACHPC", 0x00001000)
{
    /*
     * iASL Warning: There were 5 external control methods found during
     * disassembly, but only 0 were resolved (5 unresolved). Additional
     * ACPI tables may be required to properly disassemble the code. This
     * resulting disassembler output file may not compile because the
     * disassembler did not know how many arguments to assign to the
     * unresolved methods. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     *
     * To specify the tables needed to resolve external control method
     * references, the -e option can be used to specify the filenames.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.DCKD, IntObj)
    External (_SB_.PCI0.GFX0.AINT, MethodObj)    // Warning: Unknown method, guessing 2 arguments
    External (_SB_.PCI0.GFX0.IUEH, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (_SB_.PCI0.GFX0.IUER, IntObj)
    External (_SB_.PCI0.LPCB.EC0_, DeviceObj)
    External (_SB_.PCI0.LPCB.EC0_.ECMX, UnknownObj)
    External (_SB_.PCI0.LPCB.EC0_.ECRG, IntObj)
    External (_SB_.PCI0.LPCB.EC0_.GBNT, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (_SB_.PCI0.LPCB.EC0_.PTEN, UnknownObj)
    External (_SB_.PCI0.LPCB.EC0_.VBPS, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (_SB_.WMIV.GVWE, MethodObj)    // Warning: Unknown method, guessing 2 arguments
    External (BIES, UnknownObj)
    External (GTOS, UnknownObj)
    External (HEFE, UnknownObj)
    External (IUBE, UnknownObj)
    External (IUCE, UnknownObj)
    External (IUDE, UnknownObj)
    External (MDBG, IntObj)
    External (OSYS, UnknownObj)
    External (PB1E, UnknownObj)
    External (VBPS, UnknownObj)

    Method (VHBG, 1, Serialized)
    {
        If (CondRefOf (MDBG))
        {
            Return (MDBG) /* External reference */
            Arg0
        }

        Return (Zero)
    }

    Scope (\_SB)
    {
        Scope (\_SB.PCI0.LPCB.EC0)
        {
            Name (WDIS, 0xFF)
            Device (BIND)
            {
                Name (_HID, "INT33D2" /* Intel GPIO Buttons */)  // _HID: Hardware ID
                Name (_CID, "PNP0C40" /* Standard Button Controller */)  // _CID: Compatible ID
                Method (_STA, 0, Serialized)  // _STA: Status
                {
                    If (LAnd (And (IUBE, One), LGreaterEqual (\GTOS, 0x09)))
                    {
                        If (And (PB1E, One))
                        {
                            Return (0x0B)
                        }
                        Else
                        {
                            Return (0x0F)
                        }
                    }

                    Return (Zero)
                }

                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    If (LEqual (Arg0, ToUUID ("dfbcf3c5-e7a5-44e6-9c1f-29c76f6e059c") /* Power Button Device */))
                    {
                        If (LEqual (Zero, ToInteger (Arg1)))
                        {
                            Switch (ToInteger (Arg2))
                            {
                                Case (Zero)
                                {
                                    Return (Buffer (One)
                                    {
                                         0x03                                             // .
                                    })
                                }
                                Case (One)
                                {
                                    If (LEqual (And (PB1E, One), One))
                                    {
                                        Return (0x07)
                                    }

                                    Return (Zero)
                                }

                            }
                        }
                    }

                    Return (Buffer (One)
                    {
                         0x00                                             // .
                    })
                }
            }

            Device (VGBI)
            {
                Name (_HID, EisaId ("INT33D6") /* Intel Virtual Buttons Device */)  // _HID: Hardware ID
                Name (VBDS, Zero)
                Name (ONTM, Zero)
                Method (_STA, 0, Serialized)  // _STA: Status
                {
                    If (LEqual (\GTOS, 0x09))
                    {
                        If (LNotEqual (And (BIES, 0x05), Zero))
                        {
                            Return (0x0F)
                        }
                    }

                    If (LGreater (\GTOS, 0x09))
                    {
                        If (LNotEqual (And (BIES, One), Zero))
                        {
                            Return (0x0F)
                        }
                    }

                    Return (Zero)
                }

                Method (VBDL, 0, Serialized)
                {
                    Or (PB1E, 0x20, PB1E) /* External reference */
                    Acquire (\_SB.PCI0.LPCB.EC0.ECMX, 0xFFFF)
                    If (LEqual (And (PB1E, One), One))
                    {
                        Store (One, \_SB.PCI0.LPCB.EC0.PTEN) /* External reference */
                    }
                    Else
                    {
                        Store (Zero, \_SB.PCI0.LPCB.EC0.PTEN) /* External reference */
                    }

                    Release (\_SB.PCI0.LPCB.EC0.ECMX)
                }

                Method (VGBS, 0, Serialized)
                {
                    If (LEqual (ONTM, Zero))
                    {
                        If (LEqual (And (VBPS (0x10), Zero, 0x10), \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x04, One))){}
                        If (LEqual (And (VBPS (0x40), Zero, 0x40), \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x06, One))){}
                        If (LEqual (And (VBPS (0x80), Zero, 0x80), \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x07, One))){}
                        If (LEqual (WDIS, One))
                        {
                            \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x07, One)
                        }

                        Store (One, ONTM) /* \_SB_.PCI0.LPCB.EC0_.VGBI.ONTM */
                    }

                    Return (VBDS) /* \_SB_.PCI0.LPCB.EC0_.VGBI.VBDS */
                }

                Method (UPBT, 2, Serialized)
                {
                    ShiftLeft (One, Arg0, Local0)
                    If (Arg1)
                    {
                        Or (VBDS, Local0, VBDS) /* \_SB_.PCI0.LPCB.EC0_.VGBI.VBDS */
                    }
                    Else
                    {
                        And (VBDS, Not (Local0), VBDS) /* \_SB_.PCI0.LPCB.EC0_.VGBI.VBDS */
                    }
                }

                Method (GPBT, 1, Serialized)
                {
                    ShiftLeft (One, Arg0, Local0)
                    If (LEqual (And (\_SB.PCI0.LPCB.EC0.VGBI.VBDS, Local0), Local0))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                Method (PBIN, 0, Serialized)
                {
                    And (PB1E, 0xFFFFFFDF, PB1E) /* External reference */
                }
            }
        }

        Scope (\_SB)
        {
            Device (HIDD)
            {
                Name (_HID, "INT33D5")  // _HID: Hardware ID
                Name (HBSY, Zero)
                Name (HIDX, Zero)
                Name (HMDE, Zero)
                Name (HRDY, Zero)
                Name (BTLD, Zero)
                Name (BTS1, Zero)
                Name (BTEN, Zero)
                Method (_STA, 0, Serialized)  // _STA: Status
                {
                    If (LAnd (LEqual (\GTOS, 0x09), LEqual (HEFE, One)))
                    {
                        If (And (BIES, 0x10))
                        {
                            If (And (BIES, 0x0C))
                            {
                                Return (0x0F)
                            }
                        }
                        ElseIf (LNotEqual (And (BIES, 0x08), Zero))
                        {
                            Return (0x0F)
                        }
                    }

                    If (LAnd (LGreater (\GTOS, 0x09), LEqual (HEFE, One)))
                    {
                        If (LNotEqual (And (BIES, 0x0C), Zero))
                        {
                            Return (0x0F)
                        }
                    }

                    Return (Zero)
                }

                Method (HDDM, 0, Serialized)
                {
                    Name (DPKG, Package (0x04)
                    {
                        0x11111111, 
                        0x22222222, 
                        0x33333333, 
                        0x44444444
                    })
                    Return (DPKG) /* \_SB_.HIDD.HDDM.DPKG */
                }

                Method (HDEM, 0, Serialized)
                {
                    Store (Zero, HBSY) /* \_SB_.HIDD.HBSY */
                    If (LEqual (HMDE, Zero))
                    {
                        Return (HIDX) /* \_SB_.HIDD.HIDX */
                    }

                    Return (HMDE) /* \_SB_.HIDD.HMDE */
                }

                Method (HDMM, 0, Serialized)
                {
                    Return (HMDE) /* \_SB_.HIDD.HMDE */
                }

                Method (HDSM, 1, Serialized)
                {
                    Store (Arg0, HRDY) /* \_SB_.HIDD.HRDY */
                    If (LEqual (Arg0, Zero))
                    {
                        Acquire (\_SB.PCI0.LPCB.EC0.ECMX, 0xFFFF)
                        Store (Zero, \_SB.PCI0.LPCB.EC0.PTEN) /* External reference */
                        Release (\_SB.PCI0.LPCB.EC0.ECMX)
                    }
                }

                Method (HPEM, 1, Serialized)
                {
                    Store (One, HBSY) /* \_SB_.HIDD.HBSY */
                    If (LEqual (HMDE, Zero))
                    {
                        Store (Arg0, HIDX) /* \_SB_.HIDD.HIDX */
                    }
                    Else
                    {
                        Store (Arg0, HIDX) /* \_SB_.HIDD.HIDX */
                    }

                    Notify (\_SB.HIDD, 0xC0) // Hardware-Specific
                    Store (Zero, Local0)
                    While (LAnd (LLess (Local0, 0xFA), HBSY))
                    {
                        Sleep (0x04)
                        Increment (Local0)
                    }

                    If (LEqual (HBSY, One))
                    {
                        Store (Zero, HBSY) /* \_SB_.HIDD.HBSY */
                        Store (Zero, HIDX) /* \_SB_.HIDD.HIDX */
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                Method (BTNL, 0, Serialized)
                {
                    Store (One, \_SB.HIDD.BTLD)
                    Acquire (\_SB.PCI0.LPCB.EC0.ECMX, 0xFFFF)
                    If (LEqual (And (PB1E, One), One))
                    {
                        Store (One, \_SB.PCI0.LPCB.EC0.PTEN) /* External reference */
                        Store (0x1F, BTS1) /* \_SB_.HIDD.BTS1 */
                        Store (BTS1, BTEN) /* \_SB_.HIDD.BTEN */
                    }
                    Else
                    {
                        Store (Zero, \_SB.PCI0.LPCB.EC0.PTEN) /* External reference */
                        Store (Zero, \_SB.HIDD.BTS1)
                    }

                    Release (\_SB.PCI0.LPCB.EC0.ECMX)
                }

                Method (BTNE, 1, Serialized)
                {
                    Store (Or (And (Arg0, 0x1E), One), BTS1) /* \_SB_.HIDD.BTS1 */
                    Store (BTS1, BTEN) /* \_SB_.HIDD.BTEN */
                }

                Method (BTNS, 0, Serialized)
                {
                    Store (BTEN, BTS1) /* \_SB_.HIDD.BTS1 */
                    Return (BTS1) /* \_SB_.HIDD.BTS1 */
                }

                Method (BTNC, 0, Serialized)
                {
                    Return (0x1F)
                }
            }

            Method (PWPR, 0, Serialized)
            {
                If (LAnd (LGreaterEqual (OSYS, 0x07DF), \_SB.HIDD.BTLD))
                {
                    Notify (\_SB.HIDD, 0xCE) // Hardware-Specific
                }
                ElseIf (And (PB1E, 0x20))
                {
                    Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC0) // Hardware-Specific
                }
                ElseIf (CondRefOf (\_SB.PCI0.GFX0.IUER))
                {
                    Store (\_SB.PCI0.GFX0.IUER, Local0)
                    And (Local0, 0xC0, \_SB.PCI0.GFX0.IUER) /* External reference */
                    Store (\_SB.PCI0.GFX0.IUER, Local0)
                    Or (Local0, One, \_SB.PCI0.GFX0.IUER) /* External reference */
                }
            }

            Method (PWRR, 0, Serialized)
            {
                If (LAnd (LGreaterEqual (OSYS, 0x07DF), \_SB.HIDD.BTLD))
                {
                    Notify (\_SB.HIDD, 0xCF) // Hardware-Specific
                }
                ElseIf (And (PB1E, 0x20))
                {
                    Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC1) // Hardware-Specific
                }
                ElseIf (CondRefOf (\_SB.PCI0.GFX0.IUER))
                {
                    Store (\_SB.PCI0.GFX0.IUER, Local0)
                    And (Local0, 0xC0, \_SB.PCI0.GFX0.IUER) /* External reference */
                }
            }
        }

        Scope (\_SB)
        {
            Device (CIND)
            {
                Name (_HID, "INT33D3" /* Intel GPIO Buttons */)  // _HID: Hardware ID
                Name (_CID, "PNP0C60" /* Display Sensor Device */)  // _CID: Compatible ID
                Method (_STA, 0, Serialized)  // _STA: Status
                {
                    If (LAnd (And (IUCE, One), LGreaterEqual (\GTOS, 0x08)))
                    {
                        Return (0x0F)
                    }

                    Return (Zero)
                }
            }
        }

        Scope (\_SB)
        {
            Device (DIND)
            {
                Name (_HID, "INT33D4" /* Intel GPIO Buttons */)  // _HID: Hardware ID
                Name (_CID, "PNP0C70" /* Dock Sensor Device */)  // _CID: Compatible ID
                Method (_STA, 0, Serialized)  // _STA: Status
                {
                    If (LAnd (And (IUDE, One), LGreaterEqual (\GTOS, 0x08)))
                    {
                        Return (0x0F)
                    }

                    Return (Zero)
                }
            }
        }

        Scope (\_SB.PCI0.LPCB.EC0)
        {
            Name (COVS, Zero)
            Name (DOKS, Zero)
            Name (BUCG, Zero)
            Name (BUCW, Zero)
            Method (_Q30, 0, Serialized)  // _Qxx: EC Query, xx=0x00-0xFF
            {
                If (\_SB.PCI0.LPCB.EC0.ECRG)
                {
                    Acquire (\_SB.PCI0.LPCB.EC0.ECMX, 0xFFFF)
                    If (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (Zero)))
                    {
                        If (LEqual (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (Zero), Zero))
                        {
                            \_SB.PCI0.LPCB.EC0.VGBI.UPBT (Zero, One)
                            \_SB.PWPR ()
                            If (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (One))
                            {
                                Store (One, \_SB.PCI0.LPCB.EC0.BUCG)
                            }

                            If (LEqual (\GTOS, 0x09))
                            {
                                If (LAnd (LEqual (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (0x02), Zero), LEqual (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (0x03), Zero)))
                                {
                                    Store (One, \_SB.PCI0.LPCB.EC0.BUCW)
                                }
                            }
                        }
                    }

                    If (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (One)))
                    {
                        If (LEqual (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (One), Zero))
                        {
                            \_SB.PCI0.LPCB.EC0.VGBI.UPBT (One, One)
                            If (LAnd (LGreaterEqual (OSYS, 0x07DF), \_SB.HIDD.BTLD))
                            {
                                Notify (\_SB.HIDD, 0xC2) // Hardware-Specific
                            }
                            ElseIf (And (PB1E, 0x20))
                            {
                                Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC2) // Hardware-Specific
                            }
                            ElseIf (LEqual (\_SB.HIDD.HRDY, One))
                            {
                                \_SB.HIDD.HPEM (One)
                            }
                            Else
                            {
                                \_SB.PCI0.GFX0.IUEH (One)
                            }
                        }
                    }

                    If (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (0x02)))
                    {
                        If (NAnd (LOr (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (Zero), \_SB.PCI0.LPCB.EC0.VGBI.GPBT (One)), \_SB.PCI0.LPCB.EC0.VGBI.GPBT (0x02)))
                        {
                            If (LEqual (\_SB.PCI0.LPCB.EC0.BUCG, Zero))
                            {
                                \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x02, One)
                                If (LAnd (LGreaterEqual (OSYS, 0x07DF), \_SB.HIDD.BTLD))
                                {
                                    Notify (\_SB.HIDD, 0xC4) // Hardware-Specific
                                }
                                ElseIf (And (PB1E, 0x20))
                                {
                                    If (LEqual (\GTOS, 0x09))
                                    {
                                        If (BUCW)
                                        {
                                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC1) // Hardware-Specific
                                            Sleep (0x64)
                                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC2) // Hardware-Specific
                                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC6) // Hardware-Specific
                                            Sleep (0x0A)
                                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC3) // Hardware-Specific
                                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC7) // Hardware-Specific
                                        }
                                        Else
                                        {
                                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC4) // Hardware-Specific
                                        }
                                    }
                                    Else
                                    {
                                        Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC4) // Hardware-Specific
                                    }
                                }
                                ElseIf (CondRefOf (\_SB.PCI0.GFX0.IUEH))
                                {
                                    \_SB.PCI0.GFX0.IUEH (0x02)
                                }
                            }

                            If (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (Zero))
                            {
                                Store (One, \_SB.PCI0.LPCB.EC0.BUCG)
                            }
                            ElseIf (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (One))
                            {
                                Store (One, \_SB.PCI0.LPCB.EC0.BUCG)
                            }
                        }
                    }

                    If (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (0x03)))
                    {
                        If (NAnd (LOr (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (Zero), \_SB.PCI0.LPCB.EC0.VGBI.GPBT (One)), \_SB.PCI0.LPCB.EC0.VGBI.GPBT (0x03)))
                        {
                            If (LEqual (\_SB.PCI0.LPCB.EC0.BUCG, Zero))
                            {
                                \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x03, One)
                                If (LAnd (LGreaterEqual (OSYS, 0x07DF), \_SB.HIDD.BTLD))
                                {
                                    Notify (\_SB.HIDD, 0xC6) // Hardware-Specific
                                }
                                ElseIf (And (PB1E, 0x20))
                                {
                                    If (LEqual (\GTOS, 0x09))
                                    {
                                        If (BUCW)
                                        {
                                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC1) // Hardware-Specific
                                            Sleep (0x64)
                                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC2) // Hardware-Specific
                                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC0) // Hardware-Specific
                                            Sleep (0x0A)
                                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC3) // Hardware-Specific
                                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC1) // Hardware-Specific
                                        }
                                        Else
                                        {
                                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC6) // Hardware-Specific
                                        }
                                    }
                                    Else
                                    {
                                        Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC6) // Hardware-Specific
                                    }
                                }
                                ElseIf (CondRefOf (\_SB.PCI0.GFX0.IUEH))
                                {
                                    \_SB.PCI0.GFX0.IUEH (0x03)
                                }

                                If (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (Zero))
                                {
                                    Store (One, \_SB.PCI0.LPCB.EC0.BUCG)
                                }
                                ElseIf (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (One))
                                {
                                    Store (One, \_SB.PCI0.LPCB.EC0.BUCG)
                                }
                            }
                        }
                    }

                    If (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (0x04)))
                    {
                        \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x04, One)
                        If (LAnd (LGreaterEqual (OSYS, 0x07DF), \_SB.HIDD.BTLD))
                        {
                            Notify (\_SB.HIDD, 0xC8) // Hardware-Specific
                        }
                        ElseIf (And (PB1E, 0x20))
                        {
                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC8) // Hardware-Specific
                        }
                        ElseIf (CondRefOf (\_SB.PCI0.GFX0.IUEH))
                        {
                            \_SB.PCI0.GFX0.IUEH (0x04)
                        }
                    }

                    If (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (0x06)))
                    {
                        If (LGreaterEqual (\GTOS, 0x09))
                        {
                            If (And (PB1E, 0x20))
                            {
                                If (LEqual (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (0x06), Zero))
                                {
                                    \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x06, One)
                                    Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xCD) // Hardware-Specific
                                }
                            }
                        }
                        ElseIf (LEqual (\GTOS, 0x08))
                        {
                            If (CondRefOf (\_SB.PCI0.GFX0.IUEH))
                            {
                                If (LEqual (\_SB.PCI0.LPCB.EC0.COVS, Zero))
                                {
                                    Store (One, \_SB.PCI0.LPCB.EC0.COVS)
                                    \_SB.PCI0.GFX0.IUEH (0x06)
                                }
                            }
                        }
                        ElseIf (LEqual (\_SB.PCI0.LPCB.EC0.COVS, Zero))
                        {
                            Store (One, \_SB.PCI0.LPCB.EC0.COVS)
                            \_SB.WMIV.GVWE (One, Zero)
                        }
                    }

                    If (LOr (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (0x07)), LEqual (\_SB.PCI0.LPCB.EC0.WDIS, One)))
                    {
                        If (LGreaterEqual (\GTOS, 0x09))
                        {
                            If (And (PB1E, 0x20))
                            {
                                If (LEqual (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (0x07), Zero))
                                {
                                    \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x07, One)
                                    Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xCA) // Hardware-Specific
                                }
                            }
                        }
                        ElseIf (LEqual (\GTOS, 0x08))
                        {
                            If (CondRefOf (\_SB.PCI0.GFX0.IUEH))
                            {
                                If (LEqual (\_SB.PCI0.LPCB.EC0.DOKS, Zero))
                                {
                                    Store (One, \_SB.PCI0.LPCB.EC0.DOKS)
                                    \_SB.PCI0.GFX0.IUEH (0x07)
                                }
                            }
                        }
                        ElseIf (LEqual (\_SB.PCI0.LPCB.EC0.DOKS, Zero))
                        {
                            Store (One, \_SB.PCI0.LPCB.EC0.DOKS)
                            \_SB.WMIV.GVWE (One, Zero)
                        }
                    }

                    Release (\_SB.PCI0.LPCB.EC0.ECMX)
                }
            }

            Method (_Q31, 0, Serialized)  // _Qxx: EC Query, xx=0x00-0xFF
            {
                If (\_SB.PCI0.LPCB.EC0.ECRG)
                {
                    Acquire (\_SB.PCI0.LPCB.EC0.ECMX, 0xFFFF)
                    If (LAnd (LEqual (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (Zero)), Zero), \_SB.PCI0.LPCB.EC0.VGBI.GPBT (Zero)))
                    {
                        \_SB.PCI0.LPCB.EC0.VGBI.UPBT (Zero, Zero)
                        \_SB.PWRR ()
                    }

                    If (LAnd (LEqual (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (One)), Zero), \_SB.PCI0.LPCB.EC0.VGBI.GPBT (One)))
                    {
                        \_SB.PCI0.LPCB.EC0.VGBI.UPBT (One, Zero)
                        If (LAnd (LGreaterEqual (OSYS, 0x07DF), \_SB.HIDD.BTLD))
                        {
                            Notify (\_SB.HIDD, 0xC3) // Hardware-Specific
                        }
                        ElseIf (And (PB1E, 0x20))
                        {
                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC3) // Hardware-Specific
                        }
                    }

                    If (LAnd (LEqual (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (0x02)), Zero), \_SB.PCI0.LPCB.EC0.VGBI.GPBT (0x02)))
                    {
                        \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x02, Zero)
                        If (LAnd (LGreaterEqual (OSYS, 0x07DF), \_SB.HIDD.BTLD))
                        {
                            Notify (\_SB.HIDD, 0xC5) // Hardware-Specific
                        }
                        ElseIf (And (PB1E, 0x20))
                        {
                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC5) // Hardware-Specific
                        }
                    }

                    If (LAnd (LEqual (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (0x03)), Zero), \_SB.PCI0.LPCB.EC0.VGBI.GPBT (0x03)))
                    {
                        \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x03, Zero)
                        If (LAnd (LGreaterEqual (OSYS, 0x07DF), \_SB.HIDD.BTLD))
                        {
                            Notify (\_SB.HIDD, 0xC7) // Hardware-Specific
                        }
                        ElseIf (And (PB1E, 0x20))
                        {
                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC7) // Hardware-Specific
                        }
                    }

                    If (LAnd (LEqual (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (0x04)), Zero), \_SB.PCI0.LPCB.EC0.VGBI.GPBT (0x04)))
                    {
                        \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x04, Zero)
                        If (LAnd (LGreaterEqual (OSYS, 0x07DF), \_SB.HIDD.BTLD))
                        {
                            Notify (\_SB.HIDD, 0xC9) // Hardware-Specific
                        }
                        ElseIf (And (PB1E, 0x20))
                        {
                            Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xC9) // Hardware-Specific
                        }
                    }

                    If (LEqual (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (0x06)), Zero))
                    {
                        If (LGreaterEqual (\GTOS, 0x09))
                        {
                            If (And (PB1E, 0x20))
                            {
                                If (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (0x06))
                                {
                                    \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x06, Zero)
                                    Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xCC) // Hardware-Specific
                                }
                            }
                        }
                        ElseIf (LEqual (\GTOS, 0x08))
                        {
                            If (CondRefOf (\_SB.PCI0.GFX0.IUEH))
                            {
                                If (LEqual (\_SB.PCI0.LPCB.EC0.COVS, One))
                                {
                                    Store (Zero, \_SB.PCI0.LPCB.EC0.COVS)
                                    \_SB.PCI0.GFX0.IUEH (0x06)
                                }
                            }
                        }
                        ElseIf (LEqual (\_SB.PCI0.LPCB.EC0.COVS, One))
                        {
                            Store (Zero, \_SB.PCI0.LPCB.EC0.COVS)
                            \_SB.WMIV.GVWE (One, Zero)
                        }
                    }

                    If (LOr (LEqual (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (0x07)), Zero), LEqual (\_SB.PCI0.LPCB.EC0.WDIS, Zero)))
                    {
                        If (LGreaterEqual (\GTOS, 0x09))
                        {
                            If (And (PB1E, 0x20))
                            {
                                If (\_SB.PCI0.LPCB.EC0.VGBI.GPBT (0x07))
                                {
                                    \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x07, Zero)
                                    Notify (\_SB.PCI0.LPCB.EC0.VGBI, 0xCB) // Hardware-Specific
                                }
                            }
                        }
                        ElseIf (LEqual (\GTOS, 0x08))
                        {
                            If (CondRefOf (\_SB.PCI0.GFX0.IUEH))
                            {
                                If (LEqual (\_SB.PCI0.LPCB.EC0.DOKS, One))
                                {
                                    Store (Zero, \_SB.PCI0.LPCB.EC0.DOKS)
                                    \_SB.PCI0.GFX0.IUEH (0x07)
                                }
                            }
                        }
                        ElseIf (LEqual (\_SB.PCI0.LPCB.EC0.DOKS, One))
                        {
                            Store (Zero, \_SB.PCI0.LPCB.EC0.DOKS)
                            \_SB.WMIV.GVWE (One, Zero)
                        }
                    }

                    If (\_SB.PCI0.LPCB.EC0.BUCG)
                    {
                        If (LEqual (And (\_SB.PCI0.LPCB.EC0.VBPS (0x0F), Zero), Store (Zero, \_SB.PCI0.LPCB.EC0.BUCG))){}
                    }

                    If (\_SB.PCI0.LPCB.EC0.BUCW)
                    {
                        If (LEqual (And (\_SB.PCI0.LPCB.EC0.VBPS (0x0F), Zero), Store (Zero, \_SB.PCI0.LPCB.EC0.BUCW))){}
                    }

                    Release (\_SB.PCI0.LPCB.EC0.ECMX)
                }
            }
        }

        Scope (\_SB)
        {
            Method (TEPC, 1, Serialized)
            {
                If (LGreater (Arg0, Zero))
                {
                    If (\_SB.PCI0.LPCB.EC0.ECRG)
                    {
                        Acquire (\_SB.PCI0.LPCB.EC0.ECMX, 0xFFFF)
                        Store (Zero, \_SB.PCI0.LPCB.EC0.PTEN) /* External reference */
                        Release (\_SB.PCI0.LPCB.EC0.ECMX)
                    }
                }
            }

            Method (TEWC, 1, Serialized)
            {
                If (\_SB.PCI0.LPCB.EC0.ECRG)
                {
                    Acquire (\_SB.PCI0.LPCB.EC0.ECMX, 0xFFFF)
                    If (LEqual (And (PB1E, One), One))
                    {
                        Store (One, \_SB.PCI0.LPCB.EC0.PTEN) /* External reference */
                    }
                    Else
                    {
                        Store (Zero, \_SB.PCI0.LPCB.EC0.PTEN) /* External reference */
                    }

                    Release (\_SB.PCI0.LPCB.EC0.ECMX)
                }

                If (LOr (LEqual (Arg0, 0x03), LEqual (Arg0, 0x04)))
                {
                    If (\_SB.PCI0.LPCB.EC0.ECRG)
                    {
                        Acquire (\_SB.PCI0.LPCB.EC0.ECMX, 0xFFFF)
                        If (LGreaterEqual (\GTOS, 0x08))
                        {
                            If (CondRefOf (\_SB.PCI0.LPCB.EC0.VGBI))
                            {
                                If (And (\_SB.PCI0.LPCB.EC0.VBPS (0x40), Zero, \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x06, One))){}
                                Else
                                {
                                    \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x06, Zero)
                                }
                            }

                            If (LEqual (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (0x06)), One))
                            {
                                Or (\_SB.PCI0.GFX0.IUER, 0x40, \_SB.PCI0.GFX0.IUER) /* External reference */
                            }
                            Else
                            {
                                And (\_SB.PCI0.GFX0.IUER, 0xFFFFFFBF, \_SB.PCI0.GFX0.IUER) /* External reference */
                            }

                            \_SB.PCI0.GFX0.AINT (0x06, Zero)
                        }

                        If (LLessEqual (\GTOS, 0x08))
                        {
                            Store (\_SB.PCI0.LPCB.EC0.GBNT (\_SB.PCI0.LPCB.EC0.VBPS (0x06)), \_SB.PCI0.LPCB.EC0.COVS)
                        }

                        If (LGreaterEqual (\GTOS, 0x08))
                        {
                            If (CondRefOf (\_SB.PCI0.LPCB.EC0.VGBI))
                            {
                                If (LOr (And (\_SB.PCI0.LPCB.EC0.VBPS (0x80), Zero, LEqual (\_SB.PCI0.LPCB.EC0.WDIS, One)), \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x07, One))){}
                                Else
                                {
                                    \_SB.PCI0.LPCB.EC0.VGBI.UPBT (0x07, Zero)
                                }
                            }

                            If (\_SB.DCKD)
                            {
                                Or (\_SB.PCI0.GFX0.IUER, 0x80, \_SB.PCI0.GFX0.IUER) /* External reference */
                            }
                            Else
                            {
                                And (\_SB.PCI0.GFX0.IUER, 0xFFFFFF7F, \_SB.PCI0.GFX0.IUER) /* External reference */
                            }

                            \_SB.PCI0.GFX0.AINT (0x07, Zero)
                        }

                        If (LLessEqual (\GTOS, 0x08))
                        {
                            If (\_SB.DCKD)
                            {
                                Store (One, \_SB.PCI0.LPCB.EC0.DOKS)
                            }
                            Else
                            {
                                Store (Zero, \_SB.PCI0.LPCB.EC0.DOKS)
                            }
                        }

                        Release (\_SB.PCI0.LPCB.EC0.ECMX)
                    }

                    If (CondRefOf (\_SB.PCI0.LPCB.EC0.VGBI.ONTM))
                    {
                        Store (One, \_SB.PCI0.LPCB.EC0.VGBI.ONTM)
                    }
                }
            }
        }
    }
}

